{% extends "ajax/game/game.html.twig" %}
{% block title %}{{'Wiedergeburt: Privatstadt gründen'|trans({}, 'ghost')|raw}}{% endblock %}
{% block menu_text %}
    {{ parent() }}
    <li class="back-dash" x-ajax-href="{{ url('game_landing') }}">{{ 'Zum Spiel'|trans({},'global') }}</li>
{% endblock %}

{% block ajax %}
    <div class="row form">
        <div class="cell header rw-12">
            <h4>{{'Privatstadt gründen'|trans({}, 'ghost')}}</h4>
            <div class="row">
                <div class="cell padded rw-12">
                    <div class="help">{{'In Privatstädten kannst du gemeinsam mit Freunden oder in Städten zu bestimmten "Theen" zu spielen.'|trans({}, 'ghost')}}</div>

                    {% if is_granted('ROLE_CROW') %}
                        <div class="row">
                            <div class="cell padded rw-3 note note-lightest">
                                <label for="townname">{{'Name der Stadt'|trans({}, 'ghost')}}</label>
                            </div>
                            <div class="cell padded rw-3">
                                <input type="text" x-payload="townName" name="townname" id="townname" />
                            </div>
                        </div>
                    {% endif %}

                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="lang">{{'Sprache'|trans({}, 'global')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="lang" id="lang" x-payload="lang">
                                <option value="de" {% if app.user.language == 'de' %}selected{% endif %}>{{ 'Deutsch'|trans({}, 'global') }}</option>
                                <option value="en" {% if app.user.language == 'en' %}selected{% endif %}>{{ 'Englisch'|trans({}, 'global') }}</option>
                                <option value="fr" {% if app.user.language == 'fr' %}selected{% endif %}>{{ 'Französisch'|trans({}, 'global') }}</option>
                                <option value="es" {% if app.user.language == 'es' %}selected{% endif %}>{{ 'Spanisch'|trans({}, 'global') }}</option>
                                <option value="multi">{{ 'Mehrsprachig'|trans({}, 'global') }}</option>
                            </select>
                        </div>
                    </div>

                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="password">{{'Zugangscode'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <input type="text" x-payload="password" name="password" id="password"/>
                        </div>
                    </div>


                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="type">{{'Stadttyp'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="type" id="type" x-payload="townType">
                                {% for townClass in townClasses %}
                                    <option value="{{townClass.name}}">{{townClass.label|trans({}, 'game')}}</option>
                                {% endfor %}
                            </select>
                            {% if is_granted('ROLE_CROW') %}
                                <p class="small mod">
                                    <input type="checkbox" name="unprivate" id="unprivate" x-payload="unprivate" /> <label for="unprivate"><strong>{{'Nicht als Privatstadt erstellen:'|trans({}, 'ghost')}}</strong></label>
                                </p>
                            {% endif %}
                        </div>
                        {% if is_granted('ROLE_CROW') %}
                            <div class="cell padded rw-6">
                                <div class="help"><strong>{{'Nicht als Privatstadt erstellen:'|trans({}, 'ghost')}}</strong> {{'Die Stadt wird nicht in der Liste der Privatstädte, sondern in der oben gewählten Gruppe erscheinen. Diese Option hat keine Auswirkungen auf die Spielregeln oder die Vergabe von Auszeichnungen und Seelenpunkten!'|trans({}, 'ghost')}}</div>
                            </div>
                        {% endif %}
                    </div>

                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="ghoulType">{{'Ghule'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="ghoulType" id="ghoulType" x-payload="ghoulType">
                                <option value="normal" title="{{'Je nach gewähltem Stadttyp erscheinen Ghule nach den üblichen Regeln.'|trans({}, 'ghost')}}">{{'Normal'|trans({}, 'ghost')}}</option>
                                <option value="bloodthirst" title="{{'Das Auftreten von Ghulen wird nicht geändert. Allerdings kann ein Ghul seinen Hunger nur stillen, indem er einen Mitbürger verspeist.'|trans({}, 'ghost')}}">{{'Blutdurst'|trans({}, 'ghost')}}</option>
                                <option value="childtown" title="{{'Es erscheint zwar kein Ghul um Mitternacht. Dafür können andere Ereignisse das Auftreten von Ghulen auslösen.'|trans({}, 'ghost')}}">{{'Stadt der Kuscheltiere'|trans({}, 'ghost')}}</option>
                            </select>
                        </div>
                        <div class="cell padded rw-6">
                            <div class="help" id="helpGhoul"></div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="water">{{"Wasservorrat"|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <input type="number" name="water" id="water" x-payload="well"/>
                        </div>
                        <div class="cell padded rw-6">
                            <div class="help">{{'Normale Werte liegen zwischen 100 und 180. Wert ist in Pandämonium-Städten reduziert. Maximum ist 300'|trans({}, 'ghost')}}</div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label>{{'Einstellungen'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-9 mod">
                            <input type="checkbox" name="disablexml" id="disablexml" x-payload="disablexml" /> <label for="disablexml"><strong>{{'Kein XML Feed:'|trans({}, 'ghost')}}</strong> {{'XML Feed für diese Stadt deaktivieren'|trans({}, 'ghost')}}</label>
                        </div>
                    </div>

                    <h5>{{'Event-Stadt'|trans({}, 'ghost')}}</h5>
                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="rules">{{'Spezialregeln'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-9">
                            <select id="rules" name="rules" multiple x-payload="rules">
                                <option value="none" title="{{'Keine Spezialregeln'|trans({}, 'ghost')}}" selected>{{'Keine'|trans({}, 'ghost')}}</option>
                                <option value="nobuilding" title="{{'Kein Gebäude ist zu Beginn freigeschaltet. Alle müssen in der Aussenwelt gefunden werden!'|trans({}, 'ghost')}}">{{'Keine Startgebäude'|trans({}, 'ghost')}}</option>
                                <option value="poison" title="{{'Jedes Essen und jede Droge, die du zu dir nimmst, birgt ein geringes Infektionsrisiko.'|trans({}, 'ghost')}}">{{'Kontaminierte Zone'|trans({}, 'ghost')}}</option>
                                <option value="nobeta" title="{{'Betapropin steht nicht zur Verfügung.'|trans({}, 'ghost')}}">{{'Beta-Funktionen deaktivieren'|trans({}, 'ghost')}}</option>
                            </select>
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="mapsize">{{'Kartengröße'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="mapsize" id="mapsize" x-payload="mapsize">
                                <option value="auto" selected>{{'Automatisch'|trans({}, 'ghost')}}</option>
                                <option value="small">{{'Kleine Karte'|trans({}, 'ghost')}}</option>
                                <option value="normal">{{'Normale Karte'|trans({}, 'ghost')}}</option>
                                {% if is_granted('ROLE_CROW') %}
                                    <option value="large">{{'Riesige Karte'|trans({}, 'ghost')}}</option>
                                    <option value="custom">{{'Eigene Einstellung'|trans({}, 'ghost')}}</option>
                                {% endif %}
                            </select>
                        </div>
                    </div>
                    {% if is_granted('ROLE_CROW') %}
                        <div id="mapsize_e_parent" style="display: none">
                            <div class="row">
                                <div class="cell padded rw-3 note note-lightest">
                                    <label for="mapsize_e">{{'Exakte Kartengröße'|trans({}, 'ghost')}}</label>
                                </div>
                                <div class="cell padded rw-3">
                                    <input type="number" min="10" max="35" name="mapsize_e" id="mapsize_e" x-payload="mapsize_e" value="25"/>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell padded rw-3 note note-lightest">
                                    <label for="ruins_num">{{'Anzahl Ruinen'|trans({}, 'ghost')}}</label>
                                </div>
                                <div class="cell padded rw-3">
                                    <input type="number" min="0" max="30" name="ruins_num" id="ruins_num" x-payload="ruins_num" value="20"/>
                                </div>
                            </div>
                            <div class="row" id="conf_explorable_count">
                                <div class="cell padded rw-3 note note-lightest">
                                    <label for="ruins_e_num">{{'Anzahl Begehbare Ruinen'|trans({}, 'ghost')}}</label>
                                </div>
                                <div class="cell padded rw-3">
                                    <input type="number" min="1" max="5" name="ruins_e_num" id="ruins_e_num" x-payload="ruins_e_num" value="1"/>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell padded rw-3 note note-lightest">
                                <label for="mapmargin">{{'Position der Stadt'|trans({}, 'ghost')}}</label>
                            </div>
                            <div class="cell padded rw-3">
                                <select name="mapmargin" id="mapmargin" x-payload="mapmargin">
                                    <option value="normal" selected>{{'Normal'|trans({}, 'ghost')}}</option>
                                    <option value="small">{{'Eher Zentral'|trans({}, 'ghost')}}</option>
                                    <option value="center">{{'Zentral'|trans({}, 'ghost')}}</option>
                                </select>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell padded rw-3 note note-lightest">
                                <label for="seed">{{'Karten-Seed'|trans({}, 'ghost')}}:</label>
                            </div>
                            <div class="cell padded rw-3">
                                <input type="text" name="seed" id="seed" x-payload="seed" value="-1"/>
                            </div>
                            <div class="cell padded rw-6">
                                <div class="help">
                                    {% trans from "ghost"%}
                                    Seed, das eine kontrollierte Kartenerstellung ermöglicht. Erlaubt im Falle von Ereignissen, ähnliche Karten zu generieren.
                                    Gib eine positive ganze Zahl ein, um es zu aktivieren.
                                    DENKT DARÜBER NACH, DIESE GANZE ZAHL VON EINEM EREIGNIS ZUM ANDEREN ZU ÄNDERN !
                                    {% endtrans %}
                                </div>
                            </div>
                        </div>
                    {% endif %}

                    <h5>{{'Stadtmodifikationen'|trans({}, 'ghost')}}</h5>
                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="shamanMode">{{'Seelen & Schamane:'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="shamanMode" id="shamanMode" x-payload="shamanMode">
                                <option value="normal" title="{{'Der Schamane wird gewählt und die Seelen werden gequält.'|trans({}, 'ghost')}}">{{'Normal'|trans({}, 'ghost')}}</option>
                                <option value="job" title="{{'Der Schamane ist ein Beruf, die Seelen werden in der Werkstatt verwandelt.'|trans({}, 'ghost')}}">{{'Job'|trans({}, 'ghost')}}</option>
                                <option value="none" title="{{'Der Schamane und die Seelen werden deaktiviert.'|trans({}, 'ghost')}}">{{'Deaktiviert'|trans({}, 'ghost')}}</option>
                            </select>
                        </div>
                        <div class="cell padded rw-6">
                            <div class="help" id="helpShaman"></div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="nightWatchMode">{{'Nachtwache:'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="nightWatchMode" id="nightWatchMode" x-payload="nightWatchMode">
                                <option value="normal" title="{{'Die Nachtwache ist verfügbar, wenn das Gebäude "Brustwehr" errichtet wurde.'|trans({}, 'ghost')}}">{{'Normal'|trans({}, 'ghost')}}</option>
                                <option value="instant" title="{{'Die Nachtwache ist von Anfang an verfügbar.'|trans({}, 'ghost')}}">{{'Sofort'|trans({}, 'ghost')}}</option>
                                <option value="none" title="{{'Die Nachtwache ist deaktiviert.'|trans({}, 'ghost')}}">{{'Deaktiviert'|trans({}, 'ghost')}}</option>
                            </select>
                        </div>
                        <div class="cell padded rw-6">
                            <div class="help" id="helpNightWatch"></div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label>{{'Spielmodifikationen:'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-9 mod">
                            <div><input type="checkbox" name="explorableruins" id="explorableruins" x-payload="ruins" checked/> <label for="explorableruins"><strong>{{'Exploration:'|trans({}, 'ghost')}}</strong> {{'Begehbare Ruinen aktivieren'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="escorts" id="escorts" x-payload="escorts" checked/> <label for="escorts"><strong>{{'Eskorte:'|trans({}, 'ghost')}}</strong> {{'Eskorten aktivieren'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="shun" id="shun" x-payload="shun" checked/> <label for="shun"><strong>{{'Verbannung:'|trans({}, 'ghost')}}</strong> {{'Verbannung aktivieren'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="nightmode" id="nightmode" x-payload="nightmode" checked/> <label for="nightmode"><strong>{{'Nachtmodus:'|trans({}, 'ghost')}}</strong> {{'Nachtmodus aktivieren (schwerer)'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="camp" id="camp" x-payload="camp" checked/> <label for="camp"><strong>{{'Camping:'|trans({}, 'ghost')}}</strong> {{'Camping in der Wildnis aktivieren'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="ghouls" id="ghouls" x-payload="ghouls" checked/> <label for="ghouls"><strong>{{'Ghule:'|trans({}, 'ghost')}}</strong> {{'Ghule aktivieren'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="buildingdamages" id="buildingdamages" x-payload="buildingdamages" checked/> <label for="buildingdamages"><strong>{{'Gebäudeschaden:'|trans({}, 'ghost')}}</strong> {{'Gebäudeschaden aktivieren'|trans({}, 'ghost')}}</label></div>
                            <div><input type="checkbox" name="improveddump" id="improveddump" x-payload="improveddump" checked/> <label for="improveddump"><strong>{{'Verbesserte Müllhalde:'|trans({}, 'ghost')}}</strong> {{'Verbesserte Müllhalde aktivieren'|trans({}, 'ghost')}}</label></div>
                        </div>
                        <div class="cell padded rw-12">
                            <div class="help">
                                {{'Aktiviere/deaktiviere Spielmodifikationen spezifisch für diese Stadt'|trans({}, 'ghost')}}
                            </div>
                        </div>
                    </div>

                    <h5>{{'Angriffe'|trans({}, 'ghost')}}</h5>
                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label for="attack">{{'Stärke der Angriffe'|trans({}, 'ghost')}}</label>
                        </div>
                        <div class="cell padded rw-3">
                            <select name="attack" id="attack" x-payload="attacks">
                                <option value="normal">{{'Normal'|trans({}, 'ghost')}}</option>
                                <option value="easy">{{'Leiche Angriffe'|trans({}, 'ghost')}}</option>
                                <option value="hard">{{'Schwere Angriffe'|trans({}, 'ghost')}}</option>
                            </select>
                        </div>
                    </div>

                    {% if is_granted('ROLE_CROW') %}


                        <h5>{{'Raben-Optionen'|trans({}, 'ghost')}}</h5>

                        <div class="row">
                            <div class="cell padded rw-3 note note-lightest">
                                <label>{{'Spiel-Optionen'|trans({}, 'ghost')}}</label>
                            </div>

                            <div class="cell padded rw-9 mod">
                                <div><input type="checkbox" name="incarnated" id="incarnated" x-payload="incarnated" checked/> <label for="incarnated"><strong>{{'Verkörperung in der Stadt:'|trans({}, 'ghost')}}</strong> {{'Verkörpert dich in der Stadt bei ihrer Entstehung'|trans({}, 'ghost')}}</label></div>
                                <div><input type="checkbox" name="allpictos" id="allpictos" x-payload="allpictos" checked/> <label for="allpictos"><strong>{{'Abstimmung aller Piktogramme:'|trans({}, 'ghost')}}</strong> {{'Gibt die Gesamtheit der während der Stadt erhaltenen Piktogramme an, anstatt ein Drittel davon.'|trans({}, 'ghost')}}</label></div>
                                <div><input type="checkbox" name="strict_pictos" id="strict_pictos" x-payload="strict_pictos" /> <label for="strict_pictos"><strong>{{'Strikte Vergabe von Auszeichnungen:'|trans({}, 'ghost')}}</strong> {{'Vergabe von Auszeichnungen folgt den Regeln kleiner Städte.'|trans({}, 'ghost')}}</label></div>
                                <div><input type="checkbox" name="soulpoints" id="soulpoints" x-payload="soulpoints" checked/> <label for="soulpoints"><strong>{{'Seelenpunkte vergeben:'|trans({}, 'ghost')}}</strong> {{'Gibt Ihnen Seelenpunkte.'|trans({}, 'ghost')}}</label></div>
                                <div><input type="checkbox" name="negate" id="negate" x-payload="negate" checked/> <label for="negate"><strong>{{'Nach 2 Tagen negieren:'|trans({}, 'ghost')}}</strong> {{'Negiert die Stadt, wenn sie nach 2 Tagen nicht gefüllt ist.'|trans({}, 'ghost')}}</label></div>
                                <div><input type="checkbox" name="lock_door" id="lock_door" x-payload="lock_door" checked/> <label for="lock_door"><strong>{{'Tor versperren:'|trans({}, 'ghost')}}</strong> {{'Das Stadttor kann erst geöffnet werden, wenn die Stadt voll ist.'|trans({}, 'ghost')}}</label></div>
                            </div>
                        </div>

                    <div class="row">
                        <div class="cell padded rw-3 note note-lightest">
                            <label>{{'Verfügbare Berufe'|trans({}, 'ghost')}}</label>
                        </div>

                        <div class="cell padded rw-9 mod">
                            <div><input type="checkbox" x-payload="basic" name="basic" id="basic" checked/> <label for="basic"><strong>{{'Einwohner'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="collec" name="collec" id="collec" checked/> <label for="collec"><strong>{{'Buddler'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="guardian" name="guardian" id="guardian" checked/> <label for="guardian"><strong>{{'Wächter'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="hunter" name="hunter" id="hunter" checked/> <label for="hunter"><strong>{{'Aufklärer'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="tamer" name="tamer" id="tamer" checked/> <label for="tamer"><strong>{{'Dompteur'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="tech" name="tech" id="tech" checked/> <label for="tech"><strong>{{'Techniker'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="shaman" name="shaman" id="shaman"/> <label for="shaman"><strong>{{'Schamane'|trans({}, 'game')}}</strong></label></div>
                            <div><input type="checkbox" x-payload="survivalist" name="survivalist" id="survivalist" checked/> <label for="survivalist"><strong>{{'Einsiedler'|trans({}, 'game')}}</strong></label></div>
                        </div>
                    </div>
                    {% endif %}

                    <div class="warning" id="negate_warning">
                        <strong>{{'Achtung!'|trans({}, 'ghost')}}</strong> {{'Falls die Stadt night in 2 Tagen gefüllt ist, wird sie wieder negiert.'|trans({}, 'ghost')}}
                    </div>
                    <div class="row">
                        <div class="cell padded rw-12">
                            <button id="create-town-btn">{{'Diese Stadt gründen'|trans({}, 'ghost')}}</button>
                        </div>
                    </div>

                    <div class="row">
                        <div class="cell padded rw-12">
                            <button id="save-spots-btn">{{'Platzreservierung'|trans({}, 'ghost')}}</button>
                        </div>
                    </div>

                    <div class="row">
                        <div class="cell padded rw-12">
                            <div class="small"><img alt="" src="{{ asset('build/images/icons/small_rp.gif') }}" /> {{'Beginne ein neues Leben in der Welt der Verdammten une versuche, so lang wie möglich zu überleben. Wer weiß, ws dich in dieser neuen Stadt erwarten wird?'|trans({}, 'ghost')}}</div>
                        </div>
                    </div>

                </div>

            </div>

        </div>
    </div>
{% endblock %}
{% block js %}
    {{parent()}}
    <script>

        let fun_link_help = function(selector_id, help_id, f = null) {
            $.html.addEventListenerAll('#' + selector_id, 'change', function(e,elem) {
                document.getElementById(help_id).innerText = elem.querySelector('option:checked').getAttribute('title');
                if (typeof f === 'function') f(elem.value);
            }, true);
        }

        fun_link_help('ghoulType','helpGhoul');
        fun_link_help('nightWatchMode','helpNightWatch');
        fun_link_help('shamanMode','helpShaman', v => {
            if (document.getElementById('shaman')) document.getElementById('shaman').checked = (v === 'job')
        });

        $.html.addEventListenerAll('#negate', 'change', function(e,elem) {
            let w = document.getElementById('negate_warning');
            if (w) w.style.display = elem.checked ? null : 'none';
        });

        {% if is_granted('ROLE_CROW') %}
            $.html.addEventListenerAll('#mapsize', 'change', function(e,elem) {
                let w = document.getElementById('mapsize_e_parent');
                if (w) w.style.display = elem.value === 'custom' ? null : 'none';
            });
            $.html.addEventListenerAll('#explorableruins', 'change', function(e,elem) {
                let w = document.getElementById('conf_explorable_count');
                if (w) w.style.display = elem.checked ? null : 'none';
            });
        {% endif %}

        $.html.addEventListenerAll('#create-town-btn', 'click', function(){
            if (!confirm('{{ 'Bestätigen?'|trans({},'global')|e('js') }}'))
                return;

            let payload = {};

            $.html.forEach('input[type=checkbox][x-payload],input[type=radio][x-payload]', elem => payload[elem.getAttribute('x-payload')] = elem.checked );
            $.html.forEach('select[x-payload][multiple]>option:checked', elem => {
                const xpayload = elem.parentElement.getAttribute('x-payload');
                if (typeof payload[xpayload] === 'undefined') payload[xpayload] = [];
                payload[xpayload].push(elem.value);
            } );
            $.html.forEach('input:not([type=checkbox]):not([type=radio])[x-payload],textarea[x-payload],select[x-payload]:not([multiple])', elem => payload[elem.getAttribute('x-payload')] = elem.value );

            $.ajax.send( '{{ path('ghost_process_create_town') }}', payload,
                function () {
                    $.ajax.load(null, '{{ path('game_jobs') }}', true);
            } );
        });
    </script>
{% endblock %}